#!/opt/Guardian/Admin/php/bin/php
<?

require_once "util.php";
require_once "license_check.php";

define('TOUCH', '/bin/touch');
define('PHP_NAME',basename($_SERVER["PHP_SELF"]));
define('PHP_TITLE','GUARDIANWALL eml file utility');
define('VERSION','version 1.0');
define("SRT_CMD", GRDN_BASE . 'local/bin/sort');
define('ADMIN_STORE_C','/opt/Guardian/Admin/wall/bin/mw_store');
define('ADMIN_BROWSE_C','/opt/Guardian/Admin/wall/bin/mw_browsemail');

/* ǥեȥѥ᡼  */
$conffile = "/opt/Guardian/Admin/etc/admin/admin.conf";
$workdir = "/opt/Guardian/Admin/tmp";
$pidfile = "";
$subworkdir = "";
$filedel = FALSE;
$noenv = FALSE;
$maxcnt = -1;


// check uid
if (posix_getuid() != 0)
    err_exit("You need login as root.");

array_shift($argv);
while (($opt = array_shift($argv)) != null) {
    if($opt{0} != '-')
        break;
    switch ($opt{1}) {
    case 'h':
            usage();
            break;
    case 'v':
            version();
            break;
    case 'd':
            $filedel = TURE;
            break;
    case 'f':
            $conffile = array_shift($argv);
            break;
    case 'o':
            $workdir = array_shift($argv);
            $workdir = preg_replace("/\/$/","",$workdir);
            break;
    case 'q':
            $emldir = array_shift($argv);
            $emldir = preg_replace("/\/$/","",$emldir);
            break;
    case 'n':
            $maxcnt = array_shift($argv);
            if (!preg_match('/^[0-9]+$/',$maxcnt)) {
                err_exit("not number");
            }
            break;
    case 'e':
            $noenv = TRUE;
            break;
    default:
            usage();
            break;
    }
}

if ($emldir == NULL || !is_dir($emldir)) {
    err_exit("FAILED: no such directory [$emldir]");
}

//ɤ߹
if (!file_exists($conffile) || is_dir($conffile)) {
    err_exit("FAILED: no such Configfile [$conffile]");
}

if (checkLicense('archive', $conffile) == 0) {
    err_exit("FAILED: not set archive license");
}

if (ReadServerConfig('ArchiveDirectories', null, $conffile, 'Archive') == null) {
    err_exit("FAILED: not found ArchiveDirectories");
}

if (!file_exists(ADMIN_STORE_C) || is_dir(ADMIN_STORE_C)) {
    err_exit("FAILED: no such file [" . ADMIN_STORE_C . "]");
}

if (!file_exists(ADMIN_BROWSE_C) || is_dir(ADMIN_BROWSE_C)) {
    err_exit("FAILED: no such file [" . ADMIN_BROWSE_C . "]");
}

//ȥǥ쥯ȥ
if (!file_exists($workdir)) {
    if(!mkdir_tree($workdir, '0755', true)) {
        err_exit("FAILED: cannot mkdir [$workdir]");
    }
}

$pid = getmypid();
if ($pid === FALSE) {
    err_exit("FAILED: cannot get pid");
}
$subworkdir = $workdir . '/mgw.eml' . $pid;
if(!mkdir_tree($subworkdir, '0755', true)) {
    err_exit("FAILED: cannot mkdir [$subworkdir]");
}

//pidեǧ
$pidfile = "/opt/Guardian/Admin/tmp/eml2wall.pid";
if (file_exists($pidfile)) {
    if (is_active($pidfile,false) !== 0) {
        if (file_exists($subworkdir)) {
            su_rmdir($subworkdir);
        }
        guts_log_err('Lock');
        print "Lock\n";
        exit(-1);
    }
    su_rm($pidfile);
}
if (!su_exec(TOUCH . ' ' . $pidfile)) {
    err_exit("FAILED: cannot touch [$pidfile]");
}
$fp = fopen($pidfile, 'w');
if (!$fp) {
    err_exit("FAILED: cannot open [$pidfile]");
}
fputs($fp, $pid);
fclose($fp);

if (!file_exists($pidfile)) {
    if (file_exists($subworkdir)) {
        su_rmdir($subworkdir);
    }
    err_exit("FAILED: cannot create file [$pidfile]");
}

//̾ѹ
if (eml_mv($emldir,$subworkdir,$maxcnt)) {
//᡼
    if (eml_extraction($emldir,$subworkdir,$maxcnt,$noenv,$filedel,$conffile) != 0) {
        err_exit("FAILED: cannot extract eml");
    }
}

if (file_exists($pidfile)) {
    su_rm($pidfile);
}
if (file_exists($subworkdir)) {
    rmdir_tree($subworkdir, TRUE);
}

exit(0);



function usage() {
    print 'Usage: ' . basename($_SERVER["PHP_SELF"]) . " [options] \n";
    print "  -f <file>   : specify configuration file \n";
    print "  -o <dir>    : specify work directory \n";
    print "  -n <number> : specify max number of read \n";
    print "  -q <dir>    : specify eml file directory \n";
    print "  -d          : delete eml file \n";
    print "  -e          : skip envelope From,envelope To \n";
    print "  -h          : print this message \n";
    print "  -v          : print version info \n";
    exit(1);
}



function err_exit($msg) {
    global $subworkdir,$pidfile;
    if (posix_getuid() == 0)
        guts_log_err(PHP_NAME . ": $msg");
    $stderr = fopen("php://stderr", "w");
    fwrite($stderr, "$msg\n");
    fclose($stderr);
    if ($pidfile != "" && file_exists($pidfile)) {
        su_rm($pidfile);
    }
    if ($subworkdir != "" && file_exists($subworkdir)) {
        rmdir_tree($subworkdir, TRUE);
    }
    exit(-1);
}



function version() {
    print PHP_NAME . ' - ' . PHP_TITLE . ', ' . VERSION . "\n";
    exit(1);
}



function eml_mv($emldir, $workdir, $maxcnt) {
	$list = array();
	$num = 1;
	$indexfile = $workdir . '/index.list';

	if (!chdir($emldir)) {
    	err_exit("FAILED: cannot chdir [$emldir]");
	}

	$ls_cmd = ' ls -i ' . escapeshellarg($emldir);
	exec($ls_cmd, $list, $x);
	if ($x != 0) {
    	err_exit("FAILED: cannot get inode ");
	}

	for ($i=0; $i <= (int)(count($list)-1) / 1000; $i++) {
    	if (!mkdir_tree($emldir .'/'. $i, '0755', true)) {
        	err_exit("FAILED: cannot mkdir [$i]");
    	}
	}

	if (!su_exec(TOUCH . ' ' . $indexfile)) {
    	err_exit("FAILED: cannot create file [$indexfile]");
	}
	$fp = fopen($indexfile, 'w');
	if (!$fp) {
   		err_exit("FAILED: cannot open [$indexfile]");
	}

	asort($list);
	foreach($list as $eml) {
    	$eml = trim($eml);
    	$line = explode(' ',$eml,2);
    	$inode = $line[0];
    	$name = $num . '.eml';
    	if (!preg_match('/\.eml$/',$line[1]) || is_dir($line[1])) {
        	guts_log_err(PHP_NAME . ": not eml file [$line[1]]");
            print("not eml file [$line[1]] \n");
        	continue;
    	}

    	if ($maxcnt > 0 && $num > $maxcnt) {
        	break;
    	}

    	$filenames = $emldir . '/' . $name;
    	$mvfile = (int)(($num-1) / 1000) . '/' . $name;

    	$rename_cmd = 'find . -inum ' . $inode . ' -exec mv {} ' . $mvfile . ' \; 2>&1';
    	exec($rename_cmd, $opt, $x);
    	if (!file_exists($mvfile)) {
        	guts_log_err(PHP_NAME . ": FAILED: no such file [$emldir/$mvfile]");
        	print("FAILED: no such file [$emldir/$mvfile] \n");
        	continue;
    	}

    	fputs($fp, $mvfile . "\t" . $line[1] . "\n");
    	$num++;
	}
	fclose($fp);

	if ($num === 1) {
    	err_exit("FAILED: no emlfile [$emldir]");
	}

	return TRUE;
}



function eml_extraction($emldir,$workdir,$maxcnt,$noenv,$filedel,$conffile)
{
	$cnt = 0;
	$list = array();
	$loglist = array();
	$logdir = "";
	$arcdir = "";
	$eflg  = 0;

	$indexfile = $workdir . '/index.list';
	if (!file_exists($indexfile)) {
    	err_exit("FAILED: no file [$indexfile]");
	}

	$fp = fopen($indexfile, 'r');
	if (!$fp) {
    	err_exit("FAILED: cannot open [$indexfile]");
	}

	while(!feof($fp)) {
    	$line = fgets($fp);
    	if ($line === FALSE)
        	break;
    	$list = explode("\t",$line,2);
    	$emlfile = $emldir . '/' . trim($list[0]);

    	if ($cnt >= $maxcnt && $maxcnt > 0) {
        	guts_log_notice(PHP_NAME . ": Maximum of eml mails");
            print("Maximum of eml mails \n");
        	break;
    	}

    	$mailid = env_extraction($emlfile,$workdir,$noenv,$loglist);
    	if ($mailid == '') {
        	continue;
    	}

    	if (($cnt + 1) % 1000 == 0 ) {
        	$store_cmd = ADMIN_STORE_C . ' -o -q ' . $workdir . '/ -f ' . $conffile;
        	exec($store_cmd,$opt,$x);
        	if ($x != 0) {
                guts_log_err(PHP_NAME . ": FAILED: cannot Archive");
                print("FAILED: cannot Archive\n");
            	$eflg = 1;
            	break;
        	}
    	}

    	$cnt++;

    	if ($filedel) {
        	su_rm($emlfile);
    	}
	}
	fclose($fp);
	su_rm($indexfile);

	if ($eflg == 0) {
    	$store_cmd = ADMIN_STORE_C . ' -o -q ' . $workdir . '/ -f ' . $conffile;
    	exec($store_cmd,$opt,$x);
    	if ($x != 0) {
            guts_log_err(PHP_NAME . ": FAILED: cannot Archive");
            print("FAILED: cannot Archive\n");
    	}
	}

	if ($cnt > 0) {
    	$logdir = ReadServerConfig('LogDirectory','',$conffile,'Directories');
    	if ($logdir == '') {
        	return $eflg;
    	}
    	if (!preg_match('/\/$/',$logdir)) {
        	$logdir = $logdir . '/';
    	}
    	$arcdir = ReadServerConfig('ArchiveLogDirectory','',$conffile,'Directories');
    	if ($arcdir == '') {
        	return $eflg;
    	}
    	if (!preg_match('/\/$/',$arcdir)) {
        	$arcdir = $arcdir . '/';
    	}
    	$logdir = $logdir . $arcdir;
    	foreach($loglist as $log) {
        	$logfile = $logdir . $log;
        	if (file_exists($logfile) && !is_dir($logfile)) {
            	$cmd = SRT_CMD . " -u -o $logfile $logfile";
            	exec($cmd, $out, $rtn);
            	if ($rtn != 0) {
                	guts_log_err(PHP_NAME . ": cannot sort [$logfile]");
                	print("cannot sort [$logfile] \n");
            	}
        	}
    	}
	}

	return $eflg;
}



function env_extraction($emlfile,$workdir,$noenv,&$loglist)
{
    $v = array();
    $idfile = '/opt/Guardian/Admin/logs/.eml2wall_serial';

    if (!file_exists($emlfile)) {
        guts_log_err(PHP_NAME . ": FAILED: no file [$emlfile]");
        print("FAILED: no file [$emlfile] \n");
        return;
    }

    $tmpfile = $workdir . '/.mgw.eml' . getmypid() ;
    if (!su_cp($emlfile,$tmpfile)) {
        fclose($fp);
        guts_log_err(PHP_NAME . ": FAILED: cannot create tmpfile");
        print("FAILED: cannot create tmpfile \n");
        return;
    }

    $eml_cmd = ADMIN_BROWSE_C . ' -E ' . $tmpfile;
    exec($eml_cmd, $list, $x);
    if ($x != 0) {
        guts_log_err(PHP_NAME . ": FAILED: command faild [" . ADMIN_BROWSE_C . " -E $emlfile]");
        print("FAILED: command faild [" . ADMIN_BROWSE_C . " -E $emlfile] \n");
        return;
    }

    $timestamp = $list[count($list) -2];
    $timestamp = preg_replace("/^TIMESTAMP/", "", $timestamp);
    $timestamp = trim($timestamp);
    $v = explode(' ', $timestamp);
    $date = $v[1];

    if (!file_exists($idfile)) {
        if (!su_exec(TOUCH. ' ' . $idfile)) {
            su_rm($tmpfile);
            guts_log_err(PHP_NAME . ": FAILED: cannot create file [$idfile]");
            print("FAILED: cannot create file [$idfile] \n");
            return;
        }
    }
    $ifp = fopen($idfile, 'r');
    if (!$ifp) {
        su_rm($tmpfile);
        guts_log_err(PHP_NAME . ": FAILED: cannot open [$idfile]");
        print("FAILED: cannot open [$idfile] \n");
        return;
    }
    $id = fgets($ifp);
    if ($id === FALSE)
        $id = 1;
    $id = trim($id);
    if ($id === "")
        $id = 1;
    fclose($ifp);
    $ifp = fopen($idfile, 'w');
    if (!$ifp) {
        su_rm($tmpfile);
        guts_log_err(PHP_NAME . ": FAILED: cannot open [$idfile]");
        print("FAILED: cannot open [$idfile] \n");
        return;
    }
    if ($id == 9999) { 
        fputs($ifp,1);
        sleep(1);
    } else
        fputs($ifp,$id + 1);
    fclose($ifp);

    exec('hostid', $out, $x);
    if ($x != 0) {
        guts_log_err(PHP_NAME . ": FAILED: cannot get hostid");
        print("FAILED: cannot get hostid \n");
        return;
    }
    $hostid = hexdec($out[0]);

    $hour = explode(':', $date);
    $hourstr = ord('A') + $hour[0];
    if ($hourstr >= ord('I'))
        $hourstr++;
    if ($hourstr >= ord('O'))
        $hourstr++;
    $unixtime = strtotime($timestamp);

    $mailid = sprintf("%08X-%cOO%05d-%08X",$unixtime, $hourstr, $id, $hostid);

    $Ymd = date("Y/m/d",$unixtime);
    if (in_array($Ymd, $loglist) === FALSE) {
        $loglist[] = $Ymd;
    }

    $mefile = $workdir .'/me-' . $mailid;
    if (!su_exec(TOUCH . ' ' . $mefile)) {
        su_rm($tmpfile);
        guts_log_err(PHP_NAME . ": FAILED: cannot create mefile [$emlfile]");
        print("FAILED: cannot create mefile [$emlfile]\n");
        return;
    }

    $mdfile = $workdir . '/md-' . $mailid;
    su_mv($tmpfile, $mdfile);


    $mime = explode(' ', $list[count($list) -1]);
    $mimeparse = hexdec(400) + hexdec($mime[1]);
    $list[count($list) -1] = sprintf("%s %08x",$mime[0],$mimeparse);

    $fp = fopen($mefile, 'w');

    if ($noenv) {
        fputs($fp,"FROM <>\n");
        fputs($fp,"RCPT <>\n");
        for ($i = count($list) - 3; $i < count($list) ; $i++)
            fputs($fp,$list[$i] . "\n");
    } else {
        foreach($list as $line) {
            fputs($fp, $line . "\n");
        }
    }
    fputs($fp,'MAILID ' . $mailid . "\n");

    fclose($fp);

    return $mailid;
}

?>
